(*
 *
 * Jakartadoc - A documentation tool for JaKarTa. 
 * Strongly based on ocamlweb and coqdoc (see credits above)
 * Copyright (C) 2003 - 2004 Daniela JUNHO ANDRADE and Simo MELO de SOUSA
 *
 
 * coqdoc - A WEB-like tool for Coq
 * Copyright (C) 2002 Jean-Christophe FILLIATRE
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * See the GNU General Public License version 2 for more details
 * (enclosed in the file GPL).
 *)



type jakarta_module = string

type loc = int

type entry_type = 
  | Library
  | Module
  | Field
  | Type
  | Data
  | Record
  | Definition
  | Constructor


type index_entry = 
  | Def of string * entry_type
  | Ref of jakarta_module * string
  | Mod of jakarta_module * string

val find : jakarta_module -> loc -> index_entry

val add_module : jakarta_module -> unit

type module_kind = Local | JaKarTalib | Unknown

val find_module : jakarta_module -> module_kind

(*s Scan identifiers introductions from a file *)

val scan_file : string -> jakarta_module -> unit

(*s Read globalizations from a file (produced by jakartac -dump-glob) *)

val read_glob : string -> unit

(*s Indexes *)

type 'a index = { 
  idx_name : string;
  idx_entries : (char * (string * 'a) list) list;
  idx_size : int }

val all_entries : unit -> 
      (jakarta_module * entry_type) index *
      (entry_type * jakarta_module index) list

val map : (string -> 'a -> 'b) -> 'a index -> 'b index

