(*
 *
 * Jakartadoc - A documentation tool for JaKarTa. 
 * Strongly based on ocamlweb and coqdoc (see credits above)
 * Copyright (C) 2003 - 2004 Daniela JUNHO ANDRADE and Simo MELO de SOUSA
 *
 *
 * ocamlweb - A WEB-like tool for ocaml
 * Copyright (C) 1999-2001 Jean-Christophe FILLITRE and Claude MARCH
 *
 * coqdoc - A documentation tool for Coq
 * Copyright (C) 2002 Jean-Christophe FILLIATRE
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * See the GNU General Public License version 2 for more details
 * (enclosed in the file GPL).
 *)

(*i $Id: output.mli,v 1.19 2003/08/28 13:26:59 filliatr Exp $ i*)

open Index

type target_language = LaTeX | HTML | TeXmacs

val target_language : target_language ref

val set_out_file : string -> unit
val output_dir : string ref
val close : unit -> unit

val quiet : bool ref
val short : bool ref
val light : bool ref
val header_trailer : bool ref
val index : bool ref
val multi_index : bool ref
val toc : bool ref
val pdf : bool ref
val title : string ref
val author : string ref
val externals : bool ref
val jakartalib : string ref

val charset : string ref
val lindex : bool ref
val inputenc : string ref
val set_latin1 : unit -> unit
val set_utf8 : unit -> unit

val add_printing_token : string -> string option * string option -> unit
val remove_printing_token : string -> unit

val set_module : jakarta_module -> unit

val header : unit -> unit
val trailer : unit -> unit

val push_in_preamble : string -> unit

val dump_file : string -> unit

val start_module : unit -> unit

val start_doc : unit -> unit
val end_doc : unit -> unit

val start_jakarta : unit -> unit
val end_jakarta : unit -> unit

val start_code : unit -> unit
val end_code : unit -> unit

val start_inline_jakarta : unit -> unit
val end_inline_jakarta : unit -> unit

val indentation : int -> unit
val line_break : unit -> unit
val paragraph : unit -> unit
val empty_line_of_code : unit -> unit

val section : int -> (unit -> unit) -> unit

val item : int -> unit

val rule : unit -> unit

val char : char -> unit
val ident : string -> loc -> unit
val symbol : string -> unit

val latex_char : char -> unit
val latex_string : string -> unit
val html_char : char -> unit
val html_string : string -> unit
val verbatim_char : char -> unit

val start_latex_math : unit -> unit
val stop_latex_math : unit -> unit
val start_verbatim : unit -> unit
val stop_verbatim : unit -> unit

val make_index : unit -> unit
val make_toc : unit -> unit
